FORMAT: 1A
HOST: https://proxy.golemio.cz

# Golemio permission proxy

v1.0

## Versions

<!-- __DATE__ -->




# Group Authentication

## Login [POST /gateway/login]

User login.

+ Request (application/json; charset=utf-8)
    + Attributes (Credentials)

+ Response 401 (application/json; charset=utf-8)

+ Request (application/json; charset=utf-8)
    + Attributes (Credentials)
        + email: user@user.com
        + password: user

+ Response 200 (application/json; charset=utf-8)
    + Attributes (object)
        + token: fokslkdfjsdlkfjl (string)

+ Request (application/json; charset=utf-8)
    + Attributes (Credentials)
        + email: admin@admin.com
        + password: admin

+ Response 200 (application/json; charset=utf-8)
    + Attributes (object)
        + token: fokslkdfjsdlkfjl (string)


## Verify token [GET /gateway/verify]

Verifing the access token (token returned by login).

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 204

+ Response 401




# Group Api key

Apikeys management.

## Collection [/gateway/api-key]

### Key list [GET]

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 200 (application/json; charset=utf-8)
    + Attributes (array[Api key])

+ Response 401

### Create key [POST]

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 201 (application/json; charset=utf-8)
    + Attributes (Api key)

+ Response 401

## Detail [/gateway/api-key/{id}]

+ Parameters
    + id: 1 (required, number)

### Remove key [DELETE]

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 204

+ Response 400

+ Response 401

+ Response 404




# Group User

User management.

## Collection [/gateway/user]

### Create [POST]

+ Request (application/json; charset=utf-8)

    + Headers

            Referer: https://domain2/client-panel

    + Attributes
        + email: karelploc@gmail.com (required, string)
        + password: xxx (optional, string)
        + name: Karel (optional, string)
        + surname: Ploc (optional, string)

+ Response 201 (application/json; charset=utf-8)

+ Response 400

+ Response 403

+ Response 409




# Group Forgotten password

Forgotten password reset process.

## Request [/gateway/forgotten-password]

### Request reset [POST]

Create and send by email forgotten password request.

+ Request (application/json; charset=utf-8)
    + Headers

            Referer: https://domain2/client-panel

    + Attributes
        + email: karelploc@gmail.com (fixed-type, string, required)

+ Response 201 (application/json; charset=utf-8)

+ Response 403

+ Response 404

## Confirm [/gateway/forgotten-password/{code}]

+ Parameters
    + code: `59fcf981-80a3-449d-8751-c06e161bc400` (required, string) - uuid4 format code

### Confirm & change password [PUT]

+ Request (application/json; charset=utf-8)
    + Attributes
        + password: xxxx (fixed-type, string, required)

+ Response 404

+ Request (application/json; charset=utf-8)
    + Parameters
        + code: `1`
    + Attributes
        + password: test (fixed-type, string, required)

+ Response 204

+ Response 400




# Group Invitation password

New user email verification process.

## Detail & confirmation [/gateway/invitation/{code}]

+ Parameters
    + code: `59fcf981-80a3-449d-8751-c06e161bc400` (required, string) - uuid4 format code

### Check invitation [GET]

+ Request (application/json; charset=utf-8)

+ Response 404

+ Request (application/json; charset=utf-8)
    + Parameters
        + code: `1`

+ Response 200 (application/json; charset=utf-8)
    + Attributes (Invitation detail)

### Confirm and optionally set password [PUT]

+ Request (application/json; charset=utf-8)
    + Attributes
        + password: xxxx (fixed-type, string, optional)

+ Response 404

+ Request (application/json; charset=utf-8)
    + Parameters
        + code: `1`
    + Attributes
        + password: xxxx (fixed-type, string, optional)

+ Response 204

+ Response 400




# Group Rate limit

User rate limiting management.

## Rate Limit [/gateway/user/{userId}/rate-limit]

+ Parameters
    + userId: 3 (required, number)

### Set Rate Limit [PUT]

Only admin access

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

    + Attributes (object)
        + limit: 100 (fixed-type, number, required) - number of request per 24 hours

+ Response 204

+ Response 400

+ Response 403

+ response 404




# Group Role

User roles management.

## Collection [/gateway/role]

### List roles [GET]

Only admin access

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 200 (application/json; charset=utf-8)
    + Attributes (array[Role])

+ Response 403

### Create new role [POST]

Only admin access

+ Request (application/json; charset=utf-8)
    + Attributes (object)
        + label: Parkoviste (required, string)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 201 (application/json; charset=utf-8)
    + Attributes (Role)

+ Request (application/json; charset=utf-8)
    + Attributes (object)
        + label: Parkoviste (required, string)
        + parent_id: 0 (nullable, optional, number)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 404

+ Request (application/json; charset=utf-8)
    + Attributes (object)
        + label: Semafory (required, string)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 201 (application/json; charset=utf-8)
    + Attributes (Role)

+ Response 403

## Detail [/gateway/role/{id}]

+ Parameters
    + id: 1 (required, number)

### Detail [GET]

Only admin access

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 200 (application/json; charset=utf-8)
    + Attributes (Role)
        + scopes (array[Scope])

+ Response 403

+ Response 404

### Update [PATCH]

Only admin access

+ Request (application/json; charset=utf-8)
    + Attributes (object)
        + label: Parkoviste (optional, string)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 204

+ Request (application/json; charset=utf-8)
    + Attributes (object)
        + label: Parkoviste (optional, string)
        + parent_id: 0 (nullable, optional, number)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 404

+ Response 403

### Remove [DELETE]

Only admin access

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 204

+ Response 404

+ Response 403




# Group Route

Routing management. The routes defines proxy routing between endpoint url and target url.

## Collection [/gateway/route{?page,limit}]

+ Parameters
    + page: 1 (number, optional)
    + limit: 20 (number, optional)

### List routes [GET]

Only admin access

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 200 (application/json; charset=utf-8)
    + Attributes (array[Route])

+ Response 403

### Create route [POST]

Only admin access

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

    + Attributes (object)
        + endpoint: `/parkings` (required, string)
        + target_url: `http://output.gateway.golemio.cz` (required, string)
        + target_path: `/parkoviska` (optional, string)
        + public: false (optional, boolean)
        + method: `GET` (required, enum[string])
            + Members
                + POST

+ Response 201 (application/json; charset=utf-8)
    + Attributes (Route)

+ Request (application/json; charset=utf-8)
    + Attributes (object)
        + endpoint: `/semafory` (required, string)
        + target_url: `http://output.gateway.golemio.cz` (required, string)
        + target_path: `/semafory` (optional, string)
        + public: false (optional, boolean)
        + method: `GET` (required, enum[string])
            + Members
                + POST

+ Response 201 (application/json; charset=utf-8)
    + Attributes (Route)

+ Response 400

+ Response 403

+ Response 409

## Publish [/gateway/route/publish]

Proxy cache refresh.

### Publish [POST]

Only admin access.

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 204

+ Response 403

## Single [/gateway/route/{id}]

+ Parameters
    + id: 1 (number, required)

### Remove route [DELETE]

Only admin access.

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 204

+ Response 403

+ Response 404

## User Routes [/gateway/user/{userId}/route]

+ Parameters
    + userId: 1 (number, required)

### List user routes [GET]

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 200
    + Attributes (object)
        + endpoint: /parking (fixed-type, string)
        + method: GET (enum[string])
            + Members
                + POST
        + user_id: 1 (fixed-type, number)

+ Response 403

+ Response 404




# Group Scope

Link between route and role. Scope defines limitiations for role to access the route.

## Collection [/gateway/role/{roleId}/scope]

+ Parameters
    + roleId: 1 (required, number)

### List [GET]

Only admin access

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 200 (application/json; charset=utf-8)
    + Attributes (array[Scope])

+ Response 403

### Create [POST]

Only admin access

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

    + Attributes (object)
        + route_id: 1 (number, required)
        + limitations (array)
            + (object)
                + name: districts (required, string)
                + type: `in-array` (required, enum[string])
                    + Members
                        + `min-max`
                        + `ip`
                + block: true (required, boolean)
                + values (array[string], required)
                    + `praha-1`
                    + `praha-2`
            + (object)
                + name: limit (required, string)
                + type: `min-max` (required, enum[string])
                    + Members
                        + `in-array`
                        + `ip`
                + block: false (required, boolean)
                + min: 100 (optional, number)
                + max: 500 (optional, number)
            + (object)
                + name: ip (required, string)
                + type: `ip` (required, enum[string])
                    + Members
                        + `in-array`
                        + `min-max`
                + values (array[string], required)
                    + `192.168.1.*`

+ Response 201 (application/json; charset=utf-8)
    + Attributes (Scope)

+ Response 400

+ Response 403

+ Response 409

## Detail [/gateway/role/{roleId}/scope/{id}]

+ Parameters
    + roleId: 1 (required, number)
    + id: 1 (required, number)

### Detail [GET]

Only admin access

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 200 (application/json; charset=utf-8)
    + Attributes (Scope)

+ Response 403

+ Response 404

### Remove [DELETE]

Only admin access

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 204

+ Response 403

+ Response 404




# Group User role

User's roles management.

## Collection [/gateway/user/{userId}/role]

+ Parameters
    + userId: 1 (required, number)

### List [GET]

Only admin access

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 200 (application/json; charset=utf-8)
    + Attributes (array[Role])

+ Response 403

+ Response 404

## Assign & remove [/gateway/user/{userId}/role/{roleId}]

+ Parameters
    + roleId: 1 (required, number)
    + userId: 1 (required, number)

### Assign [PUT]

Only admin access

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 204

+ Response 403

+ Response 404

### Remove [DELETE]

Only admin access

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 204

+ Response 403

+ Response 404








# Data Structures

## Credentials (object)
+ email: user@user.cz (fixed-type, string, required) - User login
+ password: xxxxxxx (fixed-type, string, required) - User password

## Api key (object)
+ id: 1 (fixed-type, number)
+ code: f49f03jfljfwjfjsfljf (fixed-type, string) - JWT type access token
+ user_id: 1 (fixed-type, number) - Owner id
+ created_at: `2019-01-01 12:00:00` (fixed-type, string)
+ updated_at: `2019-01-01 12:00:00` (fixed-type, string)
+ deleted_at: `2019-01-01 12:00:00` (fixed-type, string, nullable)

## Invitation detail (object)
+ need_password: false (fixed-type, boolean) - information if the user set his password
+ already_expired: false (fixed-type, boolean) - information if the invitation has already expired
+ already_accepted: false (fixed-type, boolean) - information if the user has already accepted the invitation into the system

## Role (object)
+ id: 1 (fixed-type, number)
+ label: Parkoviste (fixed-type, string) - Label of the role
+ parent_id: 1 (fixed-type, number, nullable) - Parent role id
+ `default`: false (fixed-type, boolean)
+ created_at: `2019-01-01 12:00:00` (fixed-type, string)
+ updated_at: `2019-01-01 12:00:00` (fixed-type, string)
+ deleted_at: `2019-01-01 12:00:00` (fixed-type, string, nullable)
+ created_by_user_id: 1 (fixed-type, number)
+ updated_by_user_id: 1 (fixed-type, number, nullable)

## Route (object)
+ id: 1 (fixed-type, number)
+ endpoint: /parking (fixed-type, string)
+ target_url: `http://mojepraha.eu` (fixed-type, string)
+ target_path: `/parkoviska` (fixed-type, string)
+ public: false (fixed-type, boolean)
+ method: GET (enum[string])
    + Members
        + POST
+ created_at: `2019-01-01 12:00:00` (fixed-type, string)
+ updated_at: `2019-01-01 12:00:00` (fixed-type, string)
+ deleted_at: `2019-01-01 12:00:00` (fixed-type, string, nullable)
+ created_by_user_id: 1 (fixed-type, number)
+ updated_by_user_id: 1 (fixed-type, number, nullable)

## Scope (object)
+ id: 1 (fixed-type, number)
+ role_id: 1 (fixed-type, number)
+ route_id: 1 (fixed-type, number)
+ limitations (array)
    + (object)
        + name: districts (string)
        + type: `in-array` (string)
        + block: true (boolean)
        + values (array[string])
            + `praha-1`
            + `praha-2`
+ created_at: `2019-01-01 12:00:00` (fixed-type, string)
+ updated_at: `2019-01-01 12:00:00` (fixed-type, string)
+ deleted_at: `2019-01-01 12:00:00` (fixed-type, string, nullable)
+ created_by_user_id: 1 (fixed-type, number)
+ updated_by_user_id: 1 (fixed-type, number, nullable)